<?php

namespace Bydedi\Security;

use Bydedi\Container\ServiceProvider;
use Symfony\Component\DependencyInjection\Reference;

class SecurityServiceProvider extends ServiceProvider
{

    /**
     * Register the service provider.
     *
     * @return void
     */
    public function register()
    {
        $this->serviceContainer->register('security.driver', 'Bydedi\Security\Driver\BydediDriver')
            ->addArgument(new Reference('database.connection'));

        $this->serviceContainer->register('security.locker', 'Bydedi\Security\Locker')
            ->setArguments(array(new Reference('security.driver')));

        $this->serviceContainer->register('security.locker_subscriber', 'Bydedi\Security\EventListener\LockerListener')
            ->addArgument(new Reference('security.locker'))
            ->addArgument(new Reference('event.dispatcher'))
            ->addTag('app.event_subscriber');
    }
}
