<?php

namespace Bydedi\Template;

use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Templating\EngineInterface as EngineInterfaceSF;

interface EngineInterface extends EngineInterfaceSF
{
    public function renderResponse($view, array $parameters = array(), Response $response = null);

    public function registerClass($class_name, $class_impl);

    /**
     * Converts a template name to string if it is anything other than a string.
     */
    public function nameToString($name);

    public function registerPlugins($plugins);

    public function registerPlugin(AbstractPlugin $plugin);

    public function addTemplateDir($dir);

    public function assign($tpl_var, $value);

    public function clearCache();

    public function clearCompiledTemplate();
}
