<?php

namespace Bydedi\Utils\TemplatePlugin;

use Bydedi\Template\AbstractPlugin;
use Bydedi\Utils\I18n\Text;

class TxtPlugin extends AbstractPlugin
{

    /**
     * @var Text
     */
    protected $text;

    public function __construct(Text $text)
    {
        $this->text = $text;
    }

    public function generate($params, $template)
    {

        if (empty($params['key'])) {
            $params['key'] = $this->text->generateCode($params['value']);
        }

        $value = $this->text->getOneOrCreate($params['key'], $params['value']);

        /*if (!empty($params['tags'])) {
            $value = $texte->replaceTag($value, $params['tags']);
        }*/

        if (!empty($params["length"])) {
            $value = mb_substr($value, 0, intval($params["length"]));
        }

        return $value;

    }

    public function register()
    {
        return [
            'function',
            'txt',
            array($this, 'generate')
        ];
    }
}
